#!/bin/env dls-python
import PandATest
from collections import OrderedDict


class Encoder(PandATest.PandATest):

    def __init__(self, *args, **kwargs):
        super(Encoder, self).__init__(*args, **kwargs)

    def setup_quad(self):
        #(cmd, (expected result, +- bound of result))
        setup_quad_commands = OrderedDict([
            ('INENC{}.PROTOCOL=Quadrature'.format(self.blocknum),  ('OK', 0)),
            ('OUTENC{}.PROTOCOL=ABZ Passthrough'.format(self.blocknum), ('OK', 0))
        ])
        #SET FOR QUADRATURE
        for cmd, expected in setup_quad_commands.items():
            response = self.send_cmd(cmd)
            self.test_result.append(
                self.check_response(response, expected[0], cmd, expected[1]))

    def setup_ssi(self):
        setup_ssi_commands = OrderedDict([
            ('INENC{}.PROTOCOL=SSI'.format(self.blocknum),  ('OK', 0)),
            ('OUTENC{}.PROTOCOL=SSI'.format(self.blocknum), ('OK', 0)),
            ('INENC{}.CLK_SRC=From CLK'.format(self.blocknum), ('OK', 0))
        ])
        #SET FOR SSI
        for cmd, expected in setup_ssi_commands.items():
            response = self.send_cmd(cmd)
            self.test_result.append(
                self.check_response(response, expected[0], cmd, expected[1]))
           
    def setup_data(self):
        setup_data_commands = OrderedDict([
            ('INENC{}.PROTOCOL=SSI'.format(self.blocknum),  ('OK', 0)),
            ('OUTENC{}.PROTOCOL=DATA Passthrough'.format(self.blocknum), ('OK', 0)),
            ('INENC{}.CLK_SRC=From CLK'.format(self.blocknum), ('OK', 0)),
            ('OUTENC{}.ENABLE=ONE'.format(self.blocknum), ('OK', 0))
        ])
        #SET FOR SSI
        for cmd, expected in setup_data_commands.items():
            response = self.send_cmd(cmd)
            self.test_result.append(
                self.check_response(response, expected[0], cmd, expected[1]))

    def check_daughter_board(self):
        #CHECK FOR CONTROL ENCODERS
        response = self.send_cmd('INENC{}.DCARD_TYPE?'.format(self.blocknum))
        if 'Encoder Control' not in response:
            print "Encoder {} daughter board mismatch: {}".format(self.blocknum,
                                                                  response)
            return 1
        else:
            return 0

    def toggle_val(self, out_param, out_field, in_param, in_field, default):
        for outp in self.outputs:
            for val in [1, 0]:
                out_cmd = '{}{}.{}={}'.format(
                    out_param, self.blocknum, outp, self.toggle_cmd[val])
                self.set_output(out_cmd)
                in_cmd = '{}{}.{}?'.format(in_param, self.blocknum, '{}')
                self.toggle_check(
                    in_cmd, outp, self.ch_connect[outp], default, val)
