#!/bin/env dls-python
import PandATest
from collections import OrderedDict


class Sfp(PandATest.PandATest):

    def test_code(self):
        #(cmd, (expected result, +- tolerance of result))
        internal_commands = OrderedDict([
            ('SFP1_LBACK.SOFT_RESET=',     ('OK', 0)),
            ('SFP2_LBACK.SOFT_RESET=',     ('OK', 0)),
            ('SFP3_LBACK.SOFT_RESET=',     ('OK', 0)),
            ('SFP1_LBACK.SFP_CLK?',       ('OK=3276', 1)),
            ('SFP2_LBACK.SFP_CLK?',       ('OK=3276', 1)),
            ('SFP3_LBACK.SFP_CLK?',       ('OK=3276', 1)),
            ('SFP1_LBACK.LINK_UP?',       ('OK =1', 0)),
            ('SFP1_LBACK.ERROR_COUNT?',   ('OK =0', 0)),
            ('SFP2_LBACK.LINK_UP?',       ('OK =1', 0)),
            ('SFP2_LBACK.ERROR_COUNT?',   ('OK =0', 0)),
            ('SFP3_LBACK.LINK_UP?',       ('OK =1', 0)),
            ('SFP3_LBACK.ERROR_COUNT?',   ('OK =0', 0))
        ])

        for cmd, expected in internal_commands.items():
            response = self.send_cmd(cmd)
            self.test_result.append(
                self.check_response(response, expected[0], cmd, expected[1]))

        return not all(self.test_result)
